<template>
  <div id="student_class_grade_wrapper" class="bt-container">
    <el-breadcrumb style="font-size: 24px; margin-top: 40px; margin-bottom: 40px;" separator="|">
      <el-breadcrumb-item :to="{ path: `/a/${authType ? 'teacher' : 'student'}/NNclass/${classId}` }">
        {{ classData ? classData.name : '' }}
      </el-breadcrumb-item>
      <el-breadcrumb-item>{{ $t('STUDENT_MENU.VIEW_RESULTS') }}</el-breadcrumb-item>
      <div style="text-align: right;">
        <a href="javascript:history.back();">
          <el-button size="small">{{ $t('BOARD.BACK') }}</el-button>
        </a>
      </div> 
    </el-breadcrumb>
    <div class="one-lecture-wrapper">
      <div
        v-for="(lectureScore, index) in lectureScores"
        :key="index">
        <h2>{{ lectureScore.name }}</h2>
        <el-table
          :data="lectureScore.items">
          <el-table-column
            type="index"
            label="No."
            width="50"
            align="center">
          </el-table-column>
          <el-table-column
            :label="$t('QUESTION.TYPE')"
            width="100"
            align="center">
            <template slot-scope="scope">
              {{ typeConvert(scope.row.type) }}
            </template>
          </el-table-column>
          <el-table-column
            prop="name"
            :label="$t('QUESTION.QUES_NAME')"
            align="center">
          </el-table-column>
          <el-table-column
            :label="$t('STUDENT_MENU.SUBMIT_ANSWER')"
            width="300"
            align="center">
            <template slot-scope="scope">
              {{ scope.row.answers ? scope.row.answers.join(', ') : '' }}
            </template>
          </el-table-column>
          <el-table-column
            :label="$t('RESULT.SCORE')"
            width="100"
            align="center">
            <template slot-scope="scope">
              {{ scope.row.myScore }}
            </template>
          </el-table-column>
          <el-table-column
            label="-"
            width="200"
            align="center">
            <template slot-scope="scope">
              <el-button
                @click="showItemDetail(scope.row.lectureItemId)">
                {{ $t('LECTURE.VIEW') }}
              </el-button>
            </template>
          </el-table-column>
        </el-table>
        <el-row>
          <el-col
            :span="15"
            style="minHeight: 1px;">
          </el-col>
          <el-col
            :span="3">
            <h3>
              {{ `${$t('LECTURE.TOTAL_SCORE')}: ${lectureScore.myTotalScore}` }}
            </h3>
          </el-col>
          <el-col
            :span="3">
            <h3>
              {{ `${$t('LECTURE.PERCENTAGE')}: ${lectureScore.percentage}%` }}
            </h3>
          </el-col>
          <el-col
            :span="3">
            <h3>
              {{ `${$t('LECTURE.GRADE')}: ${lectureScore.grade}` }}
            </h3>
          </el-col>
        </el-row>
      </div>
    </div>
    <el-dialog
      :title="$t('ITEM.PREVIEW')"
      :visible.sync="dialogVisible"
      :width="`${previewWidth}%`"
      center>
      <lecture-live-item
        :data="lectureItem"
        v-if="dialogVisible"
        @isPreview="isPreview"
        />
      <br />
      <br />
      <span slot="footer" class="dialog-footer">
        <el-button
          @click="handleClose">
          {{ $t('DASHBOARD.QUIT') }}
        </el-button>
      </span>
    </el-dialog>
  </div>
</template>

<style lang="scss" scoped>
  #student_class_grade_wrapper {
    .one-lecture-wrapper {
      margin-bottom: 40px;
    }
  }

</style>

<script>
  import utils from '../../utils';
  import {
    mapActions,
    mapState,
    mapGetters
  } from 'vuex';
  import classService from '../../services/classService';
  import LectureLiveItem from '../../components/partials/LectureLiveItem';
  import lectureItemService from '../../services/lectureItemService';

  export default {
    name: 'StudentClassGrade',
    async created() {
      const vm = this;

      // const res2 = await classService.getClassLectureResult({
      //   id: vm.classId,
      //   id2: 2889
      // });

      // const res3 = await classService.getClassLectureResult({
      //   id: vm.classId,
      //   id2: 2941
      // });

      const res = await classService.getLectureResult({
        id: vm.classId,
      });

      vm.lectureScores = res.data.lecture_grades.map(lecture_grade => ({
        name: lecture_grade.lecture_name,
        lectureId: lecture_grade.lecture_id,
        myTotalScore: lecture_grade.score,
        items: lecture_grade.items,
        percentage: lecture_grade.percentage,
        grade: lecture_grade.grade,
      }));
    },
    components: {
      LectureLiveItem
    },
    data() {
      return {
        classData: null,
        lectureScores: [],
        codeName: '',
        dialogVisible: false,
        lectureItem: undefined,
      };
    },
    computed: {
      authType() {
        const vm = this;
        const jwt = vm.$store.state.auth.jwt;
        return utils.getAuthTypeFromJwt(jwt);
      },
      ...mapGetters('NNclass', [
        'currentStudyingClass',
      ]),
      classId() {
        const vm = this;
        return Number.parseInt(vm.$route.params.classId, 10);
      },
      previewWidth() {
        const vm = this;
        return vm.lectureItem !== undefined && vm.lectureItem.type === 0 && vm.lectureItem.questions.length > 0 && vm
          .lectureItem.questions[0].type === 7 ? 60 : 40;
      },
    },
    async mounted() {
      const vm = this;

      vm.classData = (await classService.getClass({
        id: vm.classId
      })).data;
    },
    methods: {
      isPreview() {
        return;
      },
      handleClose() {
        const vm = this;

        vm.dialogVisible = false;
      },
      async showItemDetail(lectureItemId) {
        const vm = this;

        vm.lectureItem = (await lectureItemService.getLectureItem({
          lectureItemId
        })).data;

        vm.dialogVisible = true;
      },
      percentRank(myScore, scores) {
        let s = 0;
        let b = 0;
        scores.forEach(score => {
          if (score < myScore) {
            s += 1;
          } else {
            b += 1;
          }
        });
        return Math.round(s / (s + b - 1) * 10000) / 100;
      },
      typeConvert(type) {
        return utils.convertScItemType(type);
      },
      async onClick(type, lectureId) {
        const vm = this;
        switch (type) {
          case 'GRADE': {
            vm.$router.push(`/a/student/class/${vm.classId}/grade/lecture/${lectureId}`);
            break;
          }
          default: {
            throw new Error(`not defined type ${type}`);
          }
        }
      },
    },
  };

</script>
